Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Execute_loop_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Execute_loop_allocation.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Execute_loop_allocation.cpp	(revision 136)
@@ -65,4 +65,5 @@
        ALLOC1_SIGNAL_IN ( in_EXECUTE_LOOP_IN_OPERATION            ,"operation"            ,Toperation_t      ,_param->_size_operation);
        ALLOC1_SIGNAL_IN ( in_EXECUTE_LOOP_IN_TYPE                 ,"type"                 ,Ttype_t           ,_param->_size_type);         
+       ALLOC1_SIGNAL_IN ( in_EXECUTE_LOOP_IN_CANCEL               ,"cancel"               ,Tcontrol_t        ,1);
        ALLOC1_SIGNAL_IN ( in_EXECUTE_LOOP_IN_STORE_QUEUE_PTR_WRITE,"store_queue_ptr_write",Tlsq_ptr_t        ,_param->_size_store_queue_ptr);
        ALLOC1_SIGNAL_IN ( in_EXECUTE_LOOP_IN_STORE_QUEUE_PTR_READ ,"store_queue_ptr_read" ,Tlsq_ptr_t        ,_param->_size_store_queue_ptr);
@@ -96,4 +97,5 @@
 //     ALLOC1_SIGNAL_OUT(out_EXECUTE_LOOP_OUT_OPERATION    ,"operation"    ,Toperation_t   ,_param->_size_operation);
 //     ALLOC1_SIGNAL_OUT(out_EXECUTE_LOOP_OUT_TYPE         ,"type"         ,Ttype_t        ,_param->_size_type);
+       ALLOC1_SIGNAL_OUT(out_EXECUTE_LOOP_OUT_CANCEL       ,"cancel"       ,Tcontrol_t     ,1);
        ALLOC1_SIGNAL_OUT(out_EXECUTE_LOOP_OUT_FLAGS        ,"flags"        ,Tspecial_data_t,_param->_size_special_data);
        ALLOC1_SIGNAL_OUT(out_EXECUTE_LOOP_OUT_EXCEPTION    ,"exception"    ,Texception_t   ,_param->_size_exception);
@@ -133,18 +135,18 @@
      }
 
-    // ~~~~~[ Interface "insert_rob" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-     {
-       ALLOC2_INTERFACE_BEGIN("insert_rob",IN, EAST, "Rename's stage : insert a new instruction in the Re Order Buffer",_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
-       
-       _ALLOC2_VALACK_IN ( in_INSERT_ROB_VAL,VAL,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
-       _ALLOC2_VALACK_OUT(out_INSERT_ROB_ACK,ACK,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
-
-       _ALLOC2_SIGNAL_IN ( in_INSERT_ROB_RD_USE    ,"rd_use"    ,Tcontrol_t        ,1                             ,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
-       _ALLOC2_SIGNAL_IN ( in_INSERT_ROB_RD_NUM_REG,"rd_num_reg",Tgeneral_address_t,_param->_size_general_register,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
-       _ALLOC2_SIGNAL_IN ( in_INSERT_ROB_RE_USE    ,"re_use"    ,Tcontrol_t        ,1                             ,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
-       _ALLOC2_SIGNAL_IN ( in_INSERT_ROB_RE_NUM_REG,"re_num_reg",Tspecial_address_t,_param->_size_special_register,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
-
-       ALLOC2_INTERFACE_END(_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
-     }
+//     // ~~~~~[ Interface "insert_rob" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+//      {
+//        ALLOC2_INTERFACE_BEGIN("insert_rob",IN, EAST, "Rename's stage : insert a new instruction in the Re Order Buffer",_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
+       
+//        _ALLOC2_VALACK_IN ( in_INSERT_ROB_VAL,VAL,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
+//        _ALLOC2_VALACK_OUT(out_INSERT_ROB_ACK,ACK,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
+
+//        _ALLOC2_SIGNAL_IN ( in_INSERT_ROB_RD_USE    ,"rd_use"    ,Tcontrol_t        ,1                             ,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
+//        _ALLOC2_SIGNAL_IN ( in_INSERT_ROB_RD_NUM_REG,"rd_num_reg",Tgeneral_address_t,_param->_size_general_register,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
+//        _ALLOC2_SIGNAL_IN ( in_INSERT_ROB_RE_USE    ,"re_use"    ,Tcontrol_t        ,1                             ,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
+//        _ALLOC2_SIGNAL_IN ( in_INSERT_ROB_RE_NUM_REG,"re_num_reg",Tspecial_address_t,_param->_size_special_register,_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
+
+//        ALLOC2_INTERFACE_END(_param->_nb_ooo_engine,_param->_nb_inst_insert_rob[it1]);
+//      }
 
 //     // ~~~~~[ Interface "retire_rob" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@ -440,5 +442,19 @@
 	 }
 
-       
+       // -----[ Interface "issue" ]-----------------------------------------
+       for (uint32_t i=0; i<_param->_nb_read_unit; i++)
+	 {
+	   dest = _name;
+
+	   PORT_MAP(_component ,src , "in_ISSUE_"+toString(i)+"_VAL",
+		                dest, "in_EXECUTE_LOOP_IN_"+toString(i)+"_VAL");
+	   PORT_MAP(_component ,src ,"out_ISSUE_"+toString(i)+"_ACK",
+		                dest,"out_EXECUTE_LOOP_IN_"+toString(i)+"_ACK");
+
+	   //out_ISSUE_READ_UNIT_VAL    
+	   // in_ISSUE_READ_UNIT_ACK    
+	   //out_ISSUE_REGISTER_UNIT_VAL
+	   // in_ISSUE_REGISTER_UNIT_ACK
+	 }
      }
 
@@ -466,4 +482,11 @@
 	   // ~~~~~[ Interface "read_unit_in" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 	   {
+	     dest = _name+"_glue";
+
+	     COMPONENT_MAP(_component ,src , "in_READ_UNIT_IN_VAL"                  ,
+		                       dest,"out_ISSUE_"+toString(i)+"_READ_UNIT_VAL");
+	     COMPONENT_MAP(_component ,src ,"out_READ_UNIT_IN_ACK"                  
+		                      ,dest, "in_ISSUE_"+toString(i)+"_READ_UNIT_ACK");
+
 	     dest = _name;
 #ifdef POSITION
@@ -472,6 +495,4 @@
 #endif
 
-	     PORT_MAP(_component ,src , "in_READ_UNIT_IN_VAL"                  ,dest , "in_EXECUTE_LOOP_IN_"+toString(i)+"_VAL"                  );
-	     PORT_MAP(_component ,src ,"out_READ_UNIT_IN_ACK"                  ,dest ,"out_EXECUTE_LOOP_IN_"+toString(i)+"_ACK"                  );
 	     if (_param->_have_port_context_id)
 	     PORT_MAP(_component ,src , "in_READ_UNIT_IN_CONTEXT_ID"           ,dest , "in_EXECUTE_LOOP_IN_"+toString(i)+"_CONTEXT_ID"           );
@@ -484,4 +505,5 @@
 	     PORT_MAP(_component ,src , "in_READ_UNIT_IN_OPERATION"            ,dest , "in_EXECUTE_LOOP_IN_"+toString(i)+"_OPERATION"            );
 	     PORT_MAP(_component ,src , "in_READ_UNIT_IN_TYPE"                 ,dest , "in_EXECUTE_LOOP_IN_"+toString(i)+"_TYPE"                 );
+	     PORT_MAP(_component ,src , "in_READ_UNIT_IN_CANCEL"               ,dest , "in_EXECUTE_LOOP_IN_"+toString(i)+"_CANCEL"               );
 	     PORT_MAP(_component ,src , "in_READ_UNIT_IN_STORE_QUEUE_PTR_WRITE",dest , "in_EXECUTE_LOOP_IN_"+toString(i)+"_STORE_QUEUE_PTR_WRITE");
 	     PORT_MAP(_component ,src , "in_READ_UNIT_IN_STORE_QUEUE_PTR_READ" ,dest , "in_EXECUTE_LOOP_IN_"+toString(i)+"_STORE_QUEUE_PTR_READ" );
@@ -533,4 +555,6 @@
 	       COMPONENT_MAP(_component ,src ,"out_READ_UNIT_OUT_"+toString(j               )+"_TYPE"                 ,
 				         dest, "in_READ_UNIT_OUT_"+toString(it_read_unit_out)+"_"+toString(j)+"_TYPE"                 );
+	       COMPONENT_MAP(_component ,src ,"out_READ_UNIT_OUT_"+toString(j               )+"_CANCEL"               ,
+				         dest, "in_READ_UNIT_OUT_"+toString(it_read_unit_out)+"_"+toString(j)+"_CANCEL"               );
 	       COMPONENT_MAP(_component ,src ,"out_READ_UNIT_OUT_"+toString(j               )+"_STORE_QUEUE_PTR_WRITE",
 				         dest, "in_READ_UNIT_OUT_"+toString(it_read_unit_out)+"_"+toString(j)+"_STORE_QUEUE_PTR_WRITE");
@@ -818,4 +842,6 @@
 	       COMPONENT_MAP(_component ,src , "in_EXECUTE_IN_TYPE"                 ,
 				         dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_0_TYPE"                 );
+	       COMPONENT_MAP(_component ,src , "in_EXECUTE_IN_CANCEL"               ,
+				         dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_0_CANCEL"               );
 	       COMPONENT_MAP(_component ,src , "in_EXECUTE_IN_STORE_QUEUE_PTR_WRITE",
 				         dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_0_STORE_QUEUE_PTR_WRITE");
@@ -876,4 +902,6 @@
 // 	       COMPONENT_MAP(_component ,src ,"out_EXECUTE_OUT_TYPE"         ,
 // 				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_0_TYPE"         );
+  	       COMPONENT_MAP(_component ,src ,"out_EXECUTE_OUT_CANCEL"       ,
+   				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_0_CANCEL"       );
   	       COMPONENT_MAP(_component ,src ,"out_EXECUTE_OUT_WRITE_RD"     ,
 				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_0_WRITE_RD"     );
@@ -946,4 +974,6 @@
 		 COMPONENT_MAP(_component ,src , "in_MEMORY_IN_"+toString(j)+"_TYPE"                 ,
 				           dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_"+toString(j)+"_TYPE"                 );
+		 COMPONENT_MAP(_component ,src , "in_MEMORY_IN_"+toString(j)+"_CANCEL"               ,
+				           dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_"+toString(j)+"_CANCEL"               );
 		 COMPONENT_MAP(_component ,src , "in_MEMORY_IN_"+toString(j)+"_STORE_QUEUE_PTR_WRITE",
 				           dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_"+toString(j)+"_STORE_QUEUE_PTR_WRITE");
@@ -1005,4 +1035,6 @@
 // 	       COMPONENT_MAP(_component ,src ,"out_MEMORY_OUT_"+toString(j)+"_TYPE"         ,
 // 				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_"+toString(j)+"_TYPE"         );
+	       COMPONENT_MAP(_component ,src ,"out_MEMORY_OUT_"+toString(j)+"_CANCEL"       ,
+ 				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_"+toString(j)+"_CANCEL"       );
   	       COMPONENT_MAP(_component ,src ,"out_MEMORY_OUT_"+toString(j)+"_WRITE_RD"     ,
 				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_"+toString(j)+"_WRITE_RD"     );
@@ -1115,4 +1147,6 @@
 // 	   COMPONENT_MAP(_component ,src , "in_WRITE_UNIT_IN_TYPE"         ,
 // 				     dest,"out_WRITE_UNIT_IN_"+toString(i)+"_TYPE"         );
+ 	   COMPONENT_MAP(_component ,src , "in_WRITE_UNIT_IN_CANCEL"       ,
+ 				     dest,"out_WRITE_UNIT_IN_"+toString(i)+"_CANCEL"       );
 	   COMPONENT_MAP(_component ,src , "in_WRITE_UNIT_IN_WRITE_RD"     ,
 				     dest,"out_WRITE_UNIT_IN_"+toString(i)+"_WRITE_RD"     );
@@ -1163,4 +1197,6 @@
 //	   PORT_MAP(_component ,src ,"out_WRITE_UNIT_OUT_TYPE"         ,
 // 				dest,"out_EXECUTE_LOOP_OUT_"+toString(i)+"_TYPE"         );
+	   PORT_MAP(_component ,src ,"out_WRITE_UNIT_OUT_CANCEL"       ,
+ 				dest,"out_EXECUTE_LOOP_OUT_"+toString(i)+"_CANCEL"       );
   	   PORT_MAP(_component ,src ,"out_WRITE_UNIT_OUT_FLAGS"        ,
 				dest,"out_EXECUTE_LOOP_OUT_"+toString(i)+"_FLAGS"        );
@@ -1279,10 +1315,15 @@
 #endif
        
-	   COMPONENT_MAP(_component ,src , "in_GPR_WRITE_"+toString(i)+"_VAL"          ,dest,"out_GPR_WRITE_REGISTER_FILE_"+toString(i)+"_VAL"          );
-	   COMPONENT_MAP(_component ,src ,"out_GPR_WRITE_"+toString(i)+"_ACK"          ,dest, "in_GPR_WRITE_REGISTER_FILE_"+toString(i)+"_ACK"          );
+	   COMPONENT_MAP(_component ,src , "in_GPR_WRITE_"+toString(i)+"_VAL"          ,
+			             dest,"out_GPR_WRITE_REGISTER_FILE_"+toString(i)+"_VAL"          );
+	   COMPONENT_MAP(_component ,src ,"out_GPR_WRITE_"+toString(i)+"_ACK"          ,
+			             dest, "in_GPR_WRITE_REGISTER_FILE_"+toString(i)+"_ACK"          );
 	   if (_param->_have_port_ooo_engine_id)
-	   COMPONENT_MAP(_component ,src , "in_GPR_WRITE_"+toString(i)+"_OOO_ENGINE_ID",dest,"out_GPR_WRITE_REGISTER_FILE_"+toString(i)+"_OOO_ENGINE_ID");
-	   COMPONENT_MAP(_component ,src , "in_GPR_WRITE_"+toString(i)+"_NUM_REG"      ,dest,"out_GPR_WRITE_REGISTER_FILE_"+toString(i)+"_NUM_REG"      );
-	   COMPONENT_MAP(_component ,src , "in_GPR_WRITE_"+toString(i)+"_DATA"         ,dest,"out_GPR_WRITE_REGISTER_FILE_"+toString(i)+"_DATA"         );
+	   COMPONENT_MAP(_component ,src , "in_GPR_WRITE_"+toString(i)+"_OOO_ENGINE_ID",
+			             dest,"out_GPR_WRITE_REGISTER_FILE_"+toString(i)+"_OOO_ENGINE_ID");
+	   COMPONENT_MAP(_component ,src , "in_GPR_WRITE_"+toString(i)+"_NUM_REG"      ,
+			             dest,"out_GPR_WRITE_REGISTER_FILE_"+toString(i)+"_NUM_REG"      );
+	   COMPONENT_MAP(_component ,src , "in_GPR_WRITE_"+toString(i)+"_DATA"         ,
+			             dest,"out_GPR_WRITE_REGISTER_FILE_"+toString(i)+"_DATA"         );
 	 }
 
@@ -1321,32 +1362,61 @@
 	   COMPONENT_MAP(_component ,src , "in_SPR_WRITE_"+toString(i)+"_DATA"         ,dest,"out_SPR_WRITE_REGISTER_FILE_"+toString(i)+"_DATA"         );
 	 }
+
+       // ~~~~~[ Interface "issue" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+       for (uint32_t i=0; i<_param->_nb_read_unit; i++)
+	 {
+	   dest = _name+"_glue";
+
+	   COMPONENT_MAP(_component ,src , "in_ISSUE_"+toString(i)+"_VAL",
+				     dest,"out_ISSUE_"+toString(i)+"_REGISTER_UNIT_VAL");
+	   COMPONENT_MAP(_component ,src ,"out_ISSUE_"+toString(i)+"_ACK",
+			             dest, "in_ISSUE_"+toString(i)+"_REGISTER_UNIT_ACK");
+
+	   dest = _name;
+#ifdef POSITION
+	   _component->interface_map (src ,"issue_"+toString(i),
+				      dest,"issue_"+toString(i));
+#endif
+
+	   if (_param->_have_port_ooo_engine_id)
+	   PORT_MAP(_component ,src , "in_ISSUE_"          +toString(i)+"_OOO_ENGINE_ID",
+				dest, "in_EXECUTE_LOOP_IN_"+toString(i)+"_OOO_ENGINE_ID");
+	   PORT_MAP(_component ,src , "in_ISSUE_"          +toString(i)+"_RD_USE"    ,
+				dest, "in_EXECUTE_LOOP_IN_"+toString(i)+"_WRITE_RD"  );
+	   PORT_MAP(_component ,src , "in_ISSUE_"          +toString(i)+"_RE_USE"    ,
+				dest, "in_EXECUTE_LOOP_IN_"+toString(i)+"_WRITE_RE"  );
+	   PORT_MAP(_component ,src , "in_ISSUE_"          +toString(i)+"_RD_NUM_REG",
+				dest, "in_EXECUTE_LOOP_IN_"+toString(i)+"_NUM_REG_RD");
+	   PORT_MAP(_component ,src , "in_ISSUE_"          +toString(i)+"_RE_NUM_REG",
+				dest, "in_EXECUTE_LOOP_IN_"+toString(i)+"_NUM_REG_RE");
+	 }
     
-       // ~~~~~[ Interface "insert_rob" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-       for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
-	 {
-	   uint32_t x=_param->_nb_inst_insert_rob [i];
+//        // ~~~~~[ Interface "insert_rob" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+//        for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
+// 	 {
+// 	   uint32_t x=_param->_nb_inst_insert_rob [i];
 	   
-	   for (uint32_t j=0; j<x; j++)
-	     {
-	       dest = _name;
-#ifdef POSITION
-	       _component->interface_map (src ,"insert_rob_"+toString(i)+"_"+toString(j),
-					  dest,"insert_rob_"+toString(i)+"_"+toString(j));
-#endif
-
-	       PORT_MAP(_component ,src , "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_VAL"       ,
-				    dest, "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_VAL"       );
-	       PORT_MAP(_component ,src ,"out_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_ACK"       ,
-				    dest,"out_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_ACK"       );
-	       PORT_MAP(_component ,src , "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_RD_USE"    ,
-				    dest, "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_RD_USE"    );
-	       PORT_MAP(_component ,src , "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_RD_NUM_REG",
-				    dest, "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_RD_NUM_REG");
-	       PORT_MAP(_component ,src , "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_RE_USE"    ,
-				    dest, "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_RE_USE"    );
-	       PORT_MAP(_component ,src , "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_RE_NUM_REG",
-				    dest, "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_RE_NUM_REG");
-	     }
-	 }
+// 	   for (uint32_t j=0; j<x; j++)
+// 	     {
+// 	       dest = _name;
+// #ifdef POSITION
+// 	       _component->interface_map (src ,"insert_rob_"+toString(i)+"_"+toString(j),
+// 					  dest,"insert_rob_"+toString(i)+"_"+toString(j));
+// #endif
+
+// 	       PORT_MAP(_component ,src , "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_VAL"       ,
+// 				    dest, "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_VAL"       );
+// 	       PORT_MAP(_component ,src ,"out_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_ACK"       ,
+// 				    dest,"out_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_ACK"       );
+// 	       PORT_MAP(_component ,src , "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_RD_USE"    ,
+// 				    dest, "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_RD_USE"    );
+// 	       PORT_MAP(_component ,src , "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_RD_NUM_REG",
+// 				    dest, "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_RD_NUM_REG");
+// 	       PORT_MAP(_component ,src , "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_RE_USE"    ,
+// 				    dest, "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_RE_USE"    );
+// 	       PORT_MAP(_component ,src , "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_RE_NUM_REG",
+// 				    dest, "in_INSERT_ROB_"+toString(i)+"_"+toString(j)+"_RE_NUM_REG");
+// 	     }
+// 	 }
 
 //        // ~~~~~[ Interface "retire_rob" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@ -1756,5 +1826,5 @@
 
     log_printf(FUNC,Execute_loop,FUNCTION,"End");
-  };
+     };
 
 }; // end namespace execute_loop
